/******************************************************
@^OWvEhCo[ vO  By T.Yokobayashi

ygp@z
   tagjump <str> {<edit> <eopt>}
      str c^OWv񕶎
      editcGfB^[Pathiȗj
      eoptcGfB^[Nwiȗj

   ֘Aϐiw肪Ȃ΁AL̊ϐQƁj
      EDITOR       cGfB^[Path
                     : vi.exe
      EDITOR_TAGOPTcGfB^[Nwi%d=sԍ, %s=̧ٖj
                     : +%d %s
   wƊϐ̎w肪Ȃ́AftHgWZGfB^[N

yRpC@z
   bcc32 tagjump.cpp
*******************************************************/
#define VERSION "tagjump.exe Ver1.01a 2006/10/14"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <process.h>

/* ftHg̃GfB^[PathƋNw */
#define EDITOR_DEFAULT			"C:\\Program Files\\WZ EDITOR\\wzeditor.exe"
#define EDITOR_TAGOPT_DEFAULT	"/j%d %s"




static int file_check(char *fn)
{
	struct ffblk finf;

	return findfirst(fn, &finf, 0);
}



static int tagjump_parse(char *s, char *fn, int fnmax, int *line)
{
	int cnt, len;
	char *p;
	char *p1;
	char *p2;
	char *p3;
	char *p4;
	char *p5;

	/* 󔒂ŋ؂ꂽ[hTl */
	cnt = 0;
	p1 = strtok(s, " ");
	if (p1) {
		cnt++;
		p2 = strtok(NULL, " ");
		if (p2) {
			cnt++;
			p3 = strtok(NULL, " ");
			if (p3) {
				cnt++;
				p4 = strtok(NULL, " ");
				if (p4) {
					cnt++;
					p5 = strtok(NULL, " ");
					if (p5) {
						cnt++;
					}
				}
			}
		}
	}

	if (cnt < 1)
		return -1;							/* s */

	if (((strcmp(p1,  "G[")==0) || (strcmp(p1, "x") == 0)) && (cnt >= 4)) {
		// Borland BCC^Cv
		// ) G[ E2268 test.cpp 16: `̊֐ 'exit' Ăяo(֐ main() )
		// ) x W2268 test.cpp 5: `̊֐ 'exit' Ăяo(֐ main() )
		len = strlen(p4);
		if ((len > 1) && (p4[len-1] == ':')) {
			p4[len-1] = '\0';

			strncpy(fn, p3, fnmax);			/* t@C */
			*line = atoi(p4);

			return 0;						/*  */
		}
	}

	p = strchr(p1, '(');
	if (p) {
		// Hitachi SHC^Cv
		// ) test.cpp(7) : 200 (E) UNDEFINED SYMBOL REFERENCE
		*p = '\0';
		strncpy(fn, p1, fnmax);				/* t@C */
		p++;
		p1 = p;

		p = strchr(p, ')');
		if (p) {
			*p = '\0';
			*line = atoi(p1);

			return 0;						/*  */
		}
	}

	p = strchr(p1, ':');
	if (p) {
		// GCC^Cv
		// ) test.cpp:5: `i' undeclared (first use in this function)
		*p = '\0';
		p++;

		len = strlen(p);
		if ((len > 1) && (p[len-1] == ':')) {
			p[len-1] = '\0';
			strncpy(fn, p1, fnmax);			/* t@C */
			*line = atoi(p);

			return 0;						/*  */
		}
	}

	if ((strcmp(p1,  "File") == 0) && (cnt >= 2)) {
		// Borland GREP^Cv
		// ) File tagjump.cpp:
		len = strlen(p2);
		if ((len > 1) && (p2[len-1] == ':')) {
			p2[len-1] = '\0';

			strncpy(fn, p2, fnmax);			/* t@C */
			*line = 1;						/* sԍ */
			return 0;						/*  */
		}
	}

	if ((strlen(p1) == 10) && (p1[4] == '/') && (p1[7] == '/') && (cnt >= 4)) {
		// DIR ^Cv
		// )2004/04/27  22:33                3,638 tagjump.cpp
		if ((strlen(p2) == 5) && (p2[2] == ':')) {
			strncpy(fn, p4, fnmax);			/* t@C */
			*line = 1;						/* sԍ */
			return 0;						/*  */
		}
	}

	if ((strlen(p1) == 4) && (cnt >= 5)) {
		// ls -l ^Cv
		// )-rw-      217 2003-01-09 16:04 test.cpp
		if ((strlen(p3) == 10) && (p3[4] == '-') && (p3[7] == '-')) {
			if ((strlen(p4) == 5) && (p4[2] == ':')) {
				strncpy(fn, p5, fnmax);		/* t@C */
				*line = 1;					/* sԍ */
				return 0;					/*  */
			}
		}
	}

	return -1;								/* s */
}



static int tagjump_execute(char *str, char *edit, char *eopt)
{
   	int line;
	char fname[_MAX_PATH];
	char arg1[_MAX_PATH + 10];

	/* ^OWv̌Ăяo */
	if (tagjump_parse(str, fname, sizeof fname, &line) == 0) {	// ?
		/* ވ̐ */
		if (strstr(eopt, "%d") != NULL)		// "%d"̕܂ł邩?
			sprintf(arg1, eopt, line, fname);
		else
			sprintf(arg1, eopt, fname);

		if (file_check(fname) == 0) {		// Ώ̧ق݂͑邩?
			/* ި̋N */
			if (spawnlp(P_NOWAIT, edit, edit, arg1, NULL) == -1)
				return -1;					// Ns
			return 0;						// N
		}
	}

	return -1;								// Ns
}



//*******( C[` )******
void main(int argc, char *argv[])
{
	int rc;
	char *p;
	char *editor;							// GfB^[Path
	char *editor_tagopt;					// GfB^[Nw

	if ((argc <= 1) || (argc >= 5)) {
		printf("%s\n", VERSION);
  		printf(	"usage:\n"
  				"\ttagjump <str> {<edit> <eopt>}\n"
  				);
		exit(1);							// G[
	}

	/* GfB^[Path̎擾 */
	editor = EDITOR_DEFAULT;

	if (argc >= 3) {						// Qȏ゠邩H
		editor = argv[2];
	}
	else {
		if ((p = getenv("EDITOR")) != NULL)	// ϐ?
			editor = p;
	}

	/* GfB^[Nw̎擾 */
	editor_tagopt = EDITOR_TAGOPT_DEFAULT;

	if (argc >= 4) {						// R邩?
		editor_tagopt = argv[3];
	}
	else {
		if ((p = getenv("EDITOR_TAGOPT")) != NULL)	// ϐ?
			editor_tagopt = p;
	}

	/* ^OWv̎s */
	rc = tagjump_execute(argv[1], editor, editor_tagopt);
	if (rc)
		exit(2);							// ^OWvsُ

	exit(0);								// I
}



#if 0
;!ytagjump.cpp ŗz
;!2004/04/26	VK쐬(nyacus Ver2.21pɍ쐬)
;!2004/04/28	DIR, ls -l^CvɑΉB
;!2005/10/06	GCC^CvɑΉB
;!2006/10/12	2,3ɃGfB^[w肪ł悤ɂAApBuild.exe
;!@ĂяoɑΉł悤ɂB
;!2006/10/14	editor_tagopt"%d"܂܂ȂꍇɑΉB
;!@(sWv@\Ȃnotepad.exeȂǂɂΉł悤ɂׁj
;!
#endif
